/*
 *		s
 *
 *		1994.5.22		T.Kobayashi
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "exec.h"
#include "err.h"

#include "inlib.h"

static	void	ExecOpeBoolean( int, int, DataStruct* );
static	void	ExecOpeInt( int, int, DataStruct* );
static	void	ExecOpeReal( int, int, DataStruct* );
extern	int	(*BreakCheck)(void);

/*
 *		̎s
 */
void	ExecExpression()
{
	DataStruct	*buf, ary ;

	if ((*BreakCheck)()) {
		ExecError("I܂");
	}

	for(;;)
	{
		switch( ExecPtr->type )
		{
			/*	萔	*/
			case CODE_CONST :
				StackPush( & ExecPtr->c.data );
				GotoNextCode();
				break ;

			/*	ϐb֐	*/
			case CODE_IDENT :
				if ( ExecPtr->ident.itype & IDENT_FUNC )
				{
					ExecFunction( ExecPtr );
				}
				else
				{
					buf = ExecRefVar();
					if ( buf->type == TYPE_NOASN )
						ExecError( "ĂȂϐQƂ܂B" );
					StackPush( buf );
				}
				break ;

			/*	Zq	*/
			case CODE_OPERATOR :
				if ( ExecPtr->ope.otype == OPE_EXP_END )
				{
					GotoNextCode();
					return ;
				}
				else if ( ExecPtr->ope.otype < OPE_SINGLE )
				{
					buf = StackTop();
					ExecOpe( ExecPtr->ope.otype, 1, buf );
					GotoNextCode();
				}
				else
				{
					buf = StackTop() - 1 ;
					ExecOpe( ExecPtr->ope.otype, 2, buf );
					GotoNextCode();
					StackRelease( buf );
				}
				break ;

			/*	z	*/
			case CODE_ARRAY :
				ary.type = TYPE_ARRAY ;
				ary.ad.size = ExecPtr->ary.asize ;
				ary.ad.ary = StackTop() - ary.ad.size + 1 ;
				StackPush( &ary );
				GotoNextCode();
				break ;
			default:
				assert( FALSE );
		}
		if ( ExecPtr == NULL )
		{
			ExecError( "̓rŃt@CGhɂȂ܂" );
		}
	}
}

/*	Zq̏	*/
void	ExecOpe( ope, args, buf )
int		ope ;
int		args ;
DataStruct	*buf ;
{
	switch( buf->type )
	{
		case TYPE_OBJECT:
			CallFunctionLocal( ope, args, buf );
			break ;
		case TYPE_BOOLEAN:
			ExecOpeBoolean( ope, args, buf );
			break ;
		case TYPE_INT:
			ExecOpeInt( ope, args, buf );
			break ;
		case TYPE_REAL:
			ExecOpeReal( ope, args, buf );
			break ;
		case TYPE_ARRAY:
		case TYPE_TYPE:
		case TYPE_FUNC:
			if ( ope == OPE_EQ )
			{
				buf[0].type = TYPE_BOOLEAN ;
				buf[0].ld.l = ( buf[0].td.t == buf[1].td.t );
			}
			else if ( ope == OPE_NOTEQ )
			{
				buf[0].type = TYPE_BOOLEAN ;
				buf[0].ld.l = ( buf[0].td.t != buf[1].td.t );
			}
			else
				ExecError( "Ž^słB" );
			break ;
		default:
			assert( FALSE );
	}
}

static	void	ExecOpeBoolean( ope, args, buf )
int		ope ;
int		args ;
DataStruct	*buf ;
{
	if ( args >= 2 && ! ( buf[1].type & (TYPE_BOOLEAN|TYPE_INT) ) )
	{
		ExecError( "_Ž^słB" );
	}

	switch( ope )
	{
		case OPE_NOT:
			buf->ld.l = ! buf->ld.l ;
			break ;
		case OPE_AND:
			buf->ld.l = ( buf[0].ld.l && buf[1].ld.l );
			break ;
		case OPE_OR:
			buf->ld.l = ( buf[0].ld.l || buf[1].ld.l );
			break ;
		case OPE_XOR:
			buf->ld.l = ( buf[0].ld.l ^ buf[1].ld.l );
			break ;
		case OPE_EQ:
			buf->ld.l = ( buf[0].ld.l == buf[1].ld.l );
			break ;
		case OPE_NOTEQ:
			buf->ld.l = ( buf[0].ld.l != buf[1].ld.l );
			break ;
		default:
			ExecError( "_Z̉ZqsłB" );
	}
}

static	void	ExecOpeInt( ope, args, buf )
int		ope ;
int		args ;
DataStruct	*buf ;
{
	if ( args >= 2 && ! ( buf[1].type & (TYPE_BOOLEAN|TYPE_INT|TYPE_REAL) ) )
	{
		ExecError( "Ž^słB" );
	}
	if ( buf[1].type == TYPE_REAL )
	{
		buf[1].type = TYPE_INT ;
		buf[1].id.i = (int)( buf[1].rd.r );
	}

#if	0
	printf( "ExecOpeInt( %d )\n", ope );
#endif

	switch( ope )
	{
		case OPE_NOT:
			buf->id.i = ! buf->id.i ;
			break ;
		case OPE_MINUS1:
			buf->id.i = - buf->id.i ;
			break ;
		case OPE_PLUS:
			buf->id.i = buf[0].id.i + buf[1].id.i ;
			break ;
		case OPE_MINUS:
			buf->id.i = buf[0].id.i - buf[1].id.i ;
			break ;
		case OPE_INC:
			buf->id.i ++ ;
			break ;
		case OPE_DEC:
			buf->id.i -- ;
			break ;
		case OPE_MULT:
			buf->id.i = buf[0].id.i * buf[1].id.i ;
			break ;
		case OPE_DIVIDE:
			if (buf[1].id.i != 0) {
				buf->id.i = buf[0].id.i / buf[1].id.i ;
			}
			break ;
		case OPE_MOD:
			buf->id.i = buf[0].id.i % buf[1].id.i ;
			break ;
		case OPE_LSFT:
			buf->id.i = buf[0].id.i << buf[1].id.i ;
			break ;
		case OPE_RSFT:
			buf->id.i = buf[0].id.i >> buf[1].id.i ;
			break ;
		case OPE_LSS:
			buf->type = TYPE_BOOLEAN ;
			buf->ld.l = ( buf[0].id.i < buf[1].id.i );
			break ;
		case OPE_GTR:
			buf->type = TYPE_BOOLEAN ;
			buf->ld.l = ( buf[0].id.i > buf[1].id.i );
			break ;
		case OPE_LSSEQ:
			buf->type = TYPE_BOOLEAN ;
			buf->ld.l = ( buf[0].id.i <= buf[1].id.i );
			break ;
		case OPE_GTREQ:
			buf->type = TYPE_BOOLEAN ;
			buf->ld.l = ( buf[0].id.i >= buf[1].id.i );
			break ;
		case OPE_EQ:
			buf->type = TYPE_BOOLEAN ;
			buf->ld.l = ( buf[0].id.i == buf[1].id.i );
			break ;
		case OPE_NOTEQ:
			buf->type = TYPE_BOOLEAN ;
			buf->ld.l = ( buf[0].id.i != buf[1].id.i );
			break ;
		case OPE_AND:
			buf->id.i = ( buf[0].id.i & buf[1].id.i );
			break ;
		case OPE_OR:
			buf->id.i = ( buf[0].id.i | buf[1].id.i );
			break ;
		case OPE_XOR:
			buf->id.i = ( buf[0].id.i ^ buf[1].id.i );
			break ;
		default:
			ExecError( "Z̉ZqsłB" );
	}
}

static	void	ExecOpeReal( ope, args, buf )
int		ope ;
int		args ;
DataStruct	*buf ;
{
	if ( args >= 2 && ! ( buf[1].type & (TYPE_BOOLEAN|TYPE_INT|TYPE_REAL) ) )
	{
		ExecError( "Ž^słB" );
	}
	if ( buf[1].type & (TYPE_BOOLEAN|TYPE_INT) )
	{
		buf[1].type = TYPE_REAL ;
		buf[1].rd.r = (float)( buf[1].id.i );
	}

	switch( ope )
	{
		case OPE_MINUS1:
			buf->rd.r = - buf->rd.r ;
			break ;
		case OPE_PLUS:
			buf->rd.r = buf[0].rd.r + buf[1].rd.r ;
			break ;
		case OPE_MINUS:
			buf->rd.r = buf[0].rd.r - buf[1].rd.r ;
			break ;
		case OPE_INC:
			buf->rd.r ++ ;
			break ;
		case OPE_DEC:
			buf->rd.r -- ;
			break ;
		case OPE_MULT:
			buf->rd.r = buf[0].rd.r * buf[1].rd.r ;
			break ;
		case OPE_DIVIDE:
			if (buf[1].rd.r > 1e-64 || buf[1].rd.r < -1e-64) {
				buf->rd.r = buf[0].rd.r / buf[1].rd.r ;
            }
			break ;
		case OPE_LSS:
			buf->type = TYPE_BOOLEAN ;
			buf->ld.l = ( buf[0].rd.r < buf[1].rd.r );
			break ;
		case OPE_GTR:
			buf->type = TYPE_BOOLEAN ;
			buf->ld.l = ( buf[0].rd.r > buf[1].rd.r );
			break ;
		case OPE_LSSEQ:
			buf->type = TYPE_BOOLEAN ;
			buf->ld.l = ( buf[0].rd.r <= buf[1].rd.r );
			break ;
		case OPE_GTREQ:
			buf->type = TYPE_BOOLEAN ;
			buf->ld.l = ( buf[0].rd.r >= buf[1].rd.r );
			break ;
		case OPE_EQ:
			buf->type = TYPE_BOOLEAN ;
			buf->ld.l = ( buf[0].rd.r == buf[1].rd.r );
			break ;
		case OPE_NOTEQ:
			buf->type = TYPE_BOOLEAN ;
			buf->ld.l = ( buf[0].rd.r != buf[1].rd.r );
			break ;
		default:
			ExecError( "Z̉ZqsłB" );
			break ;
	}
}
